import { BehaviorSubject, Subject } from 'rxjs';
import { takeUntil, filter } from 'rxjs/operators';
import { Router, ActivationEnd, ActivatedRoute } from '@angular/router';
import { Injectable, Directive, Input, TemplateRef, Component, ViewChild, NgModule, defineInjectable } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapNavbarService = /** @class */ (function () {
    function NgxBootstrapNavbarService() {
        this._templates = new Map();
        this._templates$ = new BehaviorSubject({ brand: null, left: null, right: null });
    }
    Object.defineProperty(NgxBootstrapNavbarService.prototype, "templates$", {
        get: /**
         * @return {?}
         */
        function () {
            return this._templates$.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} entry
     * @return {?}
     */
    NgxBootstrapNavbarService.prototype.setTemplate = /**
     * @param {?} entry
     * @return {?}
     */
    function (entry) {
        this._templates.set(entry.route, entry);
        this._update(entry.context);
    };
    /**
     * @param {?} entry
     * @return {?}
     */
    NgxBootstrapNavbarService.prototype.removeTemplate = /**
     * @param {?} entry
     * @return {?}
     */
    function (entry) {
        this._templates.delete(entry.route);
        this._update(entry.context);
    };
    /**
     * @private
     * @param {?} context
     * @return {?}
     */
    NgxBootstrapNavbarService.prototype._update = /**
     * @private
     * @param {?} context
     * @return {?}
     */
    function (context) {
        /** @type {?} */
        var entries = [];
        this._templates.forEach(function (v) { return entries.push(v); });
        /** @type {?} */
        var contextEntries = entries.filter(function (e) { return e.context === context; });
        contextEntries.sort(function (a, b) { return a.priority - b.priority; });
        /** @type {?} */
        var newEntries = Object.assign({}, this._templates$.value);
        newEntries[context] = contextEntries[contextEntries.length - 1] || null;
        this._templates$.next(newEntries);
    };
    NgxBootstrapNavbarService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxBootstrapNavbarService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgxBootstrapNavbarService.ngInjectableDef = defineInjectable({ factory: function NgxBootstrapNavbarService_Factory() { return new NgxBootstrapNavbarService(); }, token: NgxBootstrapNavbarService, providedIn: "root" });
    return NgxBootstrapNavbarService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapNavbarComponent = /** @class */ (function () {
    function NgxBootstrapNavbarComponent(_service, _router) {
        this._service = _service;
        this._router = _router;
        this._ngUnsubscribe = new Subject();
        this.navbarClass = 'navbar navbar-expand-lg navbar-dark bg-primary';
        this.brandTemplateRef = null;
        this.leftTemplateRef = null;
        this.rightTemplateRef = null;
    }
    Object.defineProperty(NgxBootstrapNavbarComponent.prototype, "service", {
        get: /**
         * @return {?}
         */
        function () {
            return this._service;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapNavbarComponent.prototype, "$collapse", {
        get: /**
         * @return {?}
         */
        function () {
            return jQuery(this.collapseElementRef.nativeElement);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapNavbarComponent.prototype, "routerEvents", {
        get: /**
         * @return {?}
         */
        function () {
            return (/** @type {?} */ (this._router.events
                .pipe(filter(function (e) { return e instanceof ActivationEnd; }))));
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NgxBootstrapNavbarComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.id = "ngx-bs-navbar-" + ++NgxBootstrapNavbarComponent.count;
        this.service.templates$
            .pipe(takeUntil(this._ngUnsubscribe))
            .subscribe(function (val) {
            _this.brandTemplateRef = val.brand ? val.brand.templateRef : null;
            _this.leftTemplateRef = val.left ? val.left.templateRef : null;
            _this.rightTemplateRef = val.right ? val.right.templateRef : null;
        });
        this.$collapse.collapse({ toggle: false });
        this.routerEvents
            .pipe(takeUntil(this._ngUnsubscribe))
            .subscribe(function () { return _this.$collapse.collapse('hide'); });
    };
    /**
     * @return {?}
     */
    NgxBootstrapNavbarComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this._ngUnsubscribe.next();
        this._ngUnsubscribe.complete();
    };
    /**
     * @return {?}
     */
    NgxBootstrapNavbarComponent.prototype.toggle = /**
     * @return {?}
     */
    function () {
        this.$collapse.collapse('toggle');
    };
    NgxBootstrapNavbarComponent.count = 0;
    NgxBootstrapNavbarComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-bootstrap-navbar',
                    template: "\n  <nav [attr.class]=\"navbarClass\">\n    <ng-container *ngTemplateOutlet=\"brandTemplateRef\"></ng-container>\n    <button\n      class=\"navbar-toggler\"\n      type=\"button\"\n      [attr.aria-controls]=\"id + '-collapse'\"\n      aria-expanded=\"false\"\n      aria-label=\"Toggle navigation\"\n      (click)=\"toggle()\">\n      <span class=\"navbar-toggler-icon\"></span>\n    </button>\n    <div class=\"collapse navbar-collapse\" #collapse [attr.id]=\"id + '-collapse'\">\n      <div class=\"mr-auto\">\n        <ng-container *ngTemplateOutlet=\"leftTemplateRef\"></ng-container>\n      </div>\n      <div class=\"ml-auto\">\n        <ng-container *ngTemplateOutlet=\"rightTemplateRef\"></ng-container>\n      </div>\n    </div>\n  </nav>\n  "
                }] }
    ];
    /** @nocollapse */
    NgxBootstrapNavbarComponent.ctorParameters = function () { return [
        { type: NgxBootstrapNavbarService },
        { type: Router }
    ]; };
    NgxBootstrapNavbarComponent.propDecorators = {
        collapseElementRef: [{ type: ViewChild, args: ['collapse',] }],
        navbarClass: [{ type: Input }]
    };
    return NgxBootstrapNavbarComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var NgxBsNavbarContext = {
    brand: 'brand',
    left: 'left',
    right: 'right',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapNavbarContentDirective = /** @class */ (function () {
    function NgxBootstrapNavbarContentDirective(_service, _route, _templateRef) {
        this._service = _service;
        this._route = _route;
        this._templateRef = _templateRef;
    }
    Object.defineProperty(NgxBootstrapNavbarContentDirective.prototype, "service", {
        get: /**
         * @return {?}
         */
        function () {
            return this._service;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapNavbarContentDirective.prototype, "route", {
        get: /**
         * @return {?}
         */
        function () {
            return this._route.snapshot;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapNavbarContentDirective.prototype, "templateRef", {
        get: /**
         * @return {?}
         */
        function () {
            return this._templateRef;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapNavbarContentDirective.prototype, "context", {
        get: /**
         * @return {?}
         */
        function () {
            return this.ngxBsNavbarContent;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NgxBootstrapNavbarContentDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var current = this.route;
        /** @type {?} */
        var routeCount = 0;
        while (current) {
            routeCount++;
            current = current.parent;
        }
        this.priority = routeCount;
        this.service.setTemplate(this);
    };
    /**
     * @return {?}
     */
    NgxBootstrapNavbarContentDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.service.removeTemplate(this);
    };
    NgxBootstrapNavbarContentDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxBsNavbarContent]'
                },] }
    ];
    /** @nocollapse */
    NgxBootstrapNavbarContentDirective.ctorParameters = function () { return [
        { type: NgxBootstrapNavbarService },
        { type: ActivatedRoute },
        { type: TemplateRef }
    ]; };
    NgxBootstrapNavbarContentDirective.propDecorators = {
        ngxBsNavbarContent: [{ type: Input }]
    };
    return NgxBootstrapNavbarContentDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapNavbarModule = /** @class */ (function () {
    function NgxBootstrapNavbarModule() {
    }
    /**
     * @return {?}
     */
    NgxBootstrapNavbarModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: NgxBootstrapNavbarModule,
            providers: [NgxBootstrapNavbarService]
        };
    };
    NgxBootstrapNavbarModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgxBootstrapNavbarComponent, NgxBootstrapNavbarContentDirective],
                    imports: [
                        CommonModule
                    ],
                    exports: [NgxBootstrapNavbarComponent, NgxBootstrapNavbarContentDirective]
                },] }
    ];
    return NgxBootstrapNavbarModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxBootstrapNavbarService, NgxBootstrapNavbarComponent, NgxBootstrapNavbarContentDirective, NgxBsNavbarContext, NgxBootstrapNavbarModule };

//# sourceMappingURL=nowzoo-ngx-bootstrap-navbar.js.map